#pragma once

#include <sys/types.h>
#include <sys/ptrace.h>

void safe_ptrace(__ptrace_request request, pid_t pid, void *addr, void *data);
void safe_wait(pid_t guest_pid, int *status);
void init_ptrace_host(pid_t guest_pid);
void init_ptrace_guest();
void loop_ptrace(pid_t guest_pid);